#include <stdio.h>
#include <dos.h>
#include <malloc.h>
#include <io.h>

#define WRITE_DATA_SB   0x10
#define ON_SOUND_SB	0xD1
#define OFF_SOUND_SB	0xD3

#define MAX_BASE_SB 5


int     basesSB[MAX_BASE_SB]={ 0x220, 0x230, 0x240, 0x250, 0x260 };
int	baseAddrSB=0x220;


	// 

unsigned char pascal ReadSB
        (void)
{
unsigned int value;

while (!(inp((baseAddrSB+0xE)) & 0x80));
value = inp((baseAddrSB+0xA));
return value;
}

	// ஢ 稥
	
char pascal CheckSB
	( void )
{
int i, j;
for ( j=0; j<MAX_BASE_SB; j++ )
{
baseAddrSB=basesSB[j];
outportb(baseAddrSB+6,1);
delay(10);
outportb(baseAddrSB+6,0);
delay(10);
for(i=0; i<30000; i++ )
        if ( ReadSB()==0xAA )
		return 1;
}
return 0;
}


void pascal WriteSB
        (unsigned char value)
{
while (inp(baseAddrSB+0xC) & 0x80);
outp(baseAddrSB+0xC, value);
}


void    main
	( int argc, char * argv[] )
{
long i;
char ch, ch1;
FILE *f;
signed char *raw;
unsigned sample_len;


if ( CheckSB()==1 )
	printf("S O U N D  B L A S T E R !!!!\n");
else {
	printf(", ,      ...\n");
	return;
	}

WriteSB(0xE1);
ch=ReadSB();
ch1=ReadSB();
printf(" SB- %d.%02d\n",ch,ch1);

printf("⭠  ...\n");
WriteSB(ON_SOUND_SB);
ch=0;
for ( i=0; i<100000L; i++ )
{
   WriteSB(WRITE_DATA_SB);
   WriteSB(ch);
   if ( ch==0 ) ch=255;
   else ch=0;
}
WriteSB(OFF_SOUND_SB);

if ( argc<2 ) return;

f = fopen(argv[1],"rb");
if ( f == 0 )
	printf("   䠩 롮ન - %s\n",argv[1]);
sample_len = (unsigned) filelength(fileno(f));
raw = (signed char *)malloc(sample_len);
fread(raw,1,sample_len,f);
fclose(f);

printf("ந 롮ન  ...\n");
WriteSB(ON_SOUND_SB);
for(i = 0; i < sample_len; i++)
{
   WriteSB(WRITE_DATA_SB);
   WriteSB(raw[i]);
}
WriteSB(OFF_SOUND_SB);
free(raw);

}

