#include <stdio.h>
#include <string.h>

typedef struct {
	char txt_id[20]; // "Creative Voice File\x1A"
        unsigned int offset_data; // ᬥ饭 砫 ࢮ  
	unsigned int ver; //  ᨨ
	unsigned int id; // 䨪, ᫮ ୮  ᨨ 
		  //    1234h, .. (((~ver)+0x1234)&0xFFFF)==id
} VocHeader;

typedef struct {
	unsigned char type; // ⨯ 
	unsigned long len; //   (  㦭 ⮫쪮  3  )
} VocBlock;

typedef struct {
	unsigned char rate; //  ⨧樨,    40H
	unsigned char type_zip; // ᯮᮡ 㯠 0 -  㯠
} VocBlock1;

typedef struct {
        unsigned int time; // ६ 設
        unsigned char rate; //  ⨧樨,    40H
} VocBlock3;

unsigned int marker; // થ
unsigned int count_repeat; // ᫮ ஢  

typedef struct {
        unsigned int rate; //  ⨧樨,    40H
                            // : 65536 - (256000000/rate)
                            // ८: 65536 - (25600000/(2*rate))
        unsigned char pack; // ᯮᮡ 㯠 =0  㯠
        unsigned char mode; //  : 0 - , 1 - ८
} VocBlock8;

void    main
	( int argc, char * argv[] )
{
FILE * f;
VocHeader vh;
VocBlock vb;
VocBlock1 vb1;
VocBlock3 vb3;
VocBlock8 vb8;
unsigned int rate;

if ( argc<2 ) { printf("  .voc 䠩\n"); return ; }
f=fopen(argv[1],"rb");
if ( f==0 ) { printf("  䠩 - %s\n",argv[1]); return; }
fread(&vh,sizeof(VocHeader),1,f);
if ( strncmp(vh.txt_id,"Creative Voice File\x1a",19)!=0 )
	{ printf(" \n"); goto Fin; }
printf("Creative Voice File\t - v%u.%02u\n",(vh.ver>>8)&0xFF,vh.ver&0xFF);
printf("砫\t\t\t - %Xh\n",vh.offset_data);
printf("䨪\t\t - %Xh\n",vh.id);
if((((~vh.ver)+0x1234)&0xFFFF)!=vh.id)
	{ printf(" ᮢ\n"); goto Fin; }

fseek( f, vh.offset_data, SEEK_SET );
while ( 1 )
{
	fread(&vb,sizeof(VocBlock)-1,1,f);
	vb.len&=0xffffffL; //   
	if ( ferror(f)!=0 )
		{ printf("訡 ⥭\n"); goto Fin; }
	switch ( vb.type )
	{
	case 0: printf(".\n"); goto Fin;
	case 1: printf(" :");
		fread(&vb1,sizeof(VocBlock1),1,f);
		rate = (unsigned int)(1000000/(256-vb1.rate));
		printf("  - %u, 㯠 - %u, len - %lu\n",
		 rate, vb1.type_zip, vb.len-2 );
		fseek( f, vb.len-2, SEEK_CUR );
		break;
        case 2: printf("த 㪠 : %lu\n", vb.len );
		fseek( f, vb.len, SEEK_CUR );
		break;
        case 3:
                fread(&vb3,sizeof(VocBlock3),1,f);
                printf("設 : ६ - %u,  - %u\n",
                        vb3.time, vb3.rate );
                break;
        case 4:
                fread(&marker,2,1,f);
                printf("થ - %u\n", marker );
                break;
        case 5:
                printf("  - %lu\n",vb.len);
                break;
        case 6:
                fread( &count_repeat,2,1,f );
                printf("७ - %u\n", count_repeat-1);
                break;
        case 7:
                printf(" ७\n");
                break;
        case 8:
                fread(&vb8,sizeof(VocBlock8),1,f);
                rate = (unsigned int)(256000000L/(65536L-vb8.rate));
                printf("ன :  - %u, 㯠 - %u, ० - %s\n",
                        rate, vb8.pack, vb8.mode==0?"":"८" );
                break;
        default:
		printf("T - %d ??????\n", vb.type );
		fseek( f, vb.len, SEEK_CUR );
		break;
	}
}

Fin:
fclose(f);
}

